#include "lcd1602.h"
#define LCD_RS  PORTC_6
#define LCD_RW  PORTC_7
#define LCD_EN  PORTG_0
#define LCD_D4  PORTG_1
#define LCD_D5  PORTE_3
#define LCD_D6  PORTE_0
#define LCD_D7  PORTD_0

/**************Ctr giao tiep LCD 16x2 4bit**********************/
void LCD_Enable(void){
        LCD_EN =1;
        delay_us(50);
        LCD_EN=0;
        delay_us(80);
}
//Ham Gui 4 Bit Du Lieu Ra LCD
void LCD_Send4Bit(unsigned char Data){
        LCD_D4=Data & 0x01;
        LCD_D5=(Data>>1)&1;
        LCD_D6=(Data>>2)&1;
        LCD_D7=(Data>>3)&1;
}
// Ham Gui 1 Lenh Cho LCD
void LCD_SendCommand(unsigned char command){
        LCD_Send4Bit(command >>4);/* Gui 4 bit cao */
        LCD_Enable();
        LCD_Send4Bit(command); /* Gui 4 bit thap*/
        LCD_Enable();
}
void lcd_clear(void){// Ham Xoa Man Hinh LCD
        LCD_SendCommand(0x01);
        delay_us(200);
        lcd_gotoxy(0,0);
        delay_us(20);
}
// Ham Khoi Tao LCD
void lcd_init(void){
        LCD_Send4Bit(0x00);
        delay_ms(20);
        LCD_RS=0;
        LCD_RW=0;
        LCD_Send4Bit(0x03);
        LCD_Enable();
        delay_ms(5);
        LCD_Enable();
        delay_us(100);
        LCD_Enable();
        LCD_Send4Bit(0x02);
        LCD_Enable();
        LCD_SendCommand( 0x28 ); // giao thuc 4 bit, hien thi 2 hang, ki tu 5x8
        LCD_SendCommand( 0x0c); // cho phep hien thi man hinh
        LCD_SendCommand( 0x06 ); // tang ID, khong dich khung hinh
        LCD_SendCommand(0x01); // xoa toan bo khung hinh
}
void lcd_gotoxy(unsigned char x, unsigned char y){
        unsigned char address;
        if(!y)address=(0x80+x);
        else address=(0xc0+x);
        delay_ms(1);
        LCD_SendCommand(address);
        delay_ms(1);
}
void lcd_putchar(unsigned char Data){//Ham Gui 1 Ki Tu
        LCD_RS=1;
        LCD_SendCommand(Data);
        LCD_RS=0 ;
}
void lcd_puts(char *s){//Ham gui 1 chuoi ky tu
    while(*s)
        lcd_putchar(*s++);
}