#include "robot.h"

SENSOR_DATA Ram_Sensor;
__no_init SENSOR_DATA Rom_Sensor  @0x4000;
#define LOW_BAT_ADC         490
/****************************************************
Su dung ham: Gia_tri_khoang_cach = Read_Sensor(SENSOR_TRAI_1);
Gia tri khoang cach: 1-200, =0 error
*****************************************************/
uint8_t Read_Sensor(uint8_t Sensor)
{
    uint16_t ADC_Value1, ADC_Value2;
    LED_EN = 0;
	delay_us(500);
    ADC_Value1 = ADC1_GetBufferValue(Sensor);
    LED_EN = 1;
	delay_us(500);
    ADC_Value2 = ADC1_GetBufferValue(Sensor);
    LED_EN = 0;
    ADC_Value1 = abs(ADC_Value2-ADC_Value1);
    return (0xff-(uint8_t)(ADC_Value1/4));
}
uint8_t Check_LowBattery(void)
{
    uint16_t ADC_Value;
    ADC_Value = ADC1_GetBufferValue(6);
    if(ADC_Value > LOW_BAT_ADC)return 1;
    return 0;
}
uint16_t Read_Vol_Battery(void)
{
    uint16_t ADC_Value, Vol;
    ADC_Value = ADC1_GetBufferValue(6);
    Vol = ((uint32_t)1800*1024)/ADC_Value;
    return Vol+100;
}
uint8_t Read_Random()
{
    uint8_t random;
    random = rand()%5;
    return random;
}
/****************************************************
Su dung ham: Gia_tri = Sensor_Color();
Gia tri: 1 or 0      =1 Dung la mau xanh
*****************************************************/
uint8_t Sensor_Color(void)
{
    uint16_t ADC_Value;
    ADC_Value = ADC1_GetBufferValue(3);
    if(ADC_Value < Ram_Sensor.Color+30 && ADC_Value > Ram_Sensor.Color-30)return 1;
    return 0;
}
/****************************************************
Su dung ham: Motor_Driver(DIR_DI_THANG, 255);
*****************************************************/
void Motor_Driver(uint8_t Dir, uint8_t Speed)
{
    if(Dir == DIR_DI_THANG){
       PWM_SetDuty(0, Speed, 0, Speed);
    }else if(Dir == DIR_LUI_LAI){
       PWM_SetDuty(Speed, 0, Speed, 0);
    }else if(Dir == DIR_QUAY_PHAI){
       PWM_SetDuty(Speed, 0, 0, Speed);
    }else if(Dir == DIR_QUAY_TRAI){
       PWM_SetDuty(0, Speed, Speed, 0);
    }else{   //STOP
       PWM_SetDuty(0, 0, 0, 0);
    }
}
/****************************************************
Su dung ham: Robot_Process();
*****************************************************/
#define Sensor_SetLR           247
//#define Sensor_SetC         170
#define TIME_TURN_90        650
#define TIME_TURN_180       1400
#define DELAY_TURN          700
uint8_t Duty_Offset, Debug = 0, time_out=240, t0;
uint16_t Val_1, Val_2;
void Robot_Process(void) //Ham chuong trinh xu ly cua Robot
{
    char str[20];
    uint8_t SensorL, SensorR, SensorL2, SensorR2, SensorC, SensorStop, dir_rand;
    SensorL = Read_Sensor(SENSOR_TRAI_1); //Gia tri cang cao thi khoang cach cang xa
    SensorR = Read_Sensor(SENSOR_PHAI_1); //MAX 255
    SensorL2 = Read_Sensor(SENSOR_TRAI_2);
    SensorR2 = Read_Sensor(SENSOR_PHAI_2);
    SensorC = Read_Sensor(SENSOR_TRUOC);
    SensorStop = Sensor_Color();
    Ram_Sensor.Center = 225;
    Ram_Sensor.Left1 = Ram_Sensor.Left2 = Ram_Sensor.Right1 = Ram_Sensor.Right2 = Sensor_SetLR;
    if(Debug){ // =1 On Debug    =0 Off Debug
        if(Debug==1){ //Read Vol Bat
            Val_1 = Read_Vol_Battery();
            lcd_clear();
            sprintf(str, "VBAT: %i mV", Val_1);
            lcd_puts(str);
            lcd_gotoxy(0,1);
            Val_1 = ADC1_GetBufferValue(6);
            sprintf(str, "ADC: %i", Val_1);
            lcd_puts(str);
            if(Val_1 > LOW_BAT_ADC)lcd_puts(" LOW");
            lcd_gotoxy(13,1);
            lcd_putchar(':');
            lcd_putchar(time_out/10+48);
            lcd_putchar(time_out%10+48);
            if(++t0>9){ t0=0; if(time_out>0)time_out--; else Debug=0; }
            delay_ms(100);
            return;
        }else if(Debug==2){
            lcd_clear();
            sprintf(str, "%u-%u  %u",  SensorL, SensorR, SensorC);
            lcd_puts(str);
            lcd_gotoxy(0,1);
            sprintf(str, "%u-%u  %i", SensorL2, SensorR2, ADC1_GetBufferValue(3));
            lcd_puts(str);
            delay_ms(50);
            if(!PIND_1){
                delay_ms(20);
                if(!PIND_1){  //Save
                    //Val_2 = ( (uint16_t)SensorL + SensorL2 + SensorR + SensorR2 )/4;
                    if(SensorL>60)Ram_Sensor.Left1 = SensorL-20;
                    else Ram_Sensor.Left1 = SensorL-10;
                    if(SensorL2>60)Ram_Sensor.Left2 = SensorL2-20;
                    else Ram_Sensor.Left2 = SensorL2-10;
                    if(SensorR>60)Ram_Sensor.Right1 = SensorR-20;
                    else Ram_Sensor.Right1 = SensorR2-10;
                    if(SensorR2>60)Ram_Sensor.Right2 = SensorR2-20;
                    else Ram_Sensor.Right2 = SensorR2-10;
                    Val_2 = ADC1_GetBufferValue(3);
                    Ram_Sensor.Color = Val_2;
                    Ram_Sensor.Center = SensorC-20;
                    Rom_Sensor = Ram_Sensor;
                    Debug=0;
                    lcd_clear();
                    sprintf(str, "SAVE: C%u B%i", Ram_Sensor.Center, Ram_Sensor.Color);
                    lcd_puts(str);
                    lcd_gotoxy(0,1);
                    sprintf(str, "%u-%u %u-%u", Ram_Sensor.Left1, Ram_Sensor.Right1, Ram_Sensor.Left2, Ram_Sensor.Right2);
                    lcd_puts(str);
                    while(!PIND_1);
                    delay_ms(10000);
                    Debug=0;
                }
            }
            return;
        }else if(Debug==3){
            if(SensorC<Ram_Sensor.Center){
                Motor_Driver(DIR_DUNG_LAI, 0); VLED=1;
                lcd_clear();
                lcd_puts("Het Duong!");
                lcd_gotoxy(0,1); delay_ms(200);
                lcd_puts("-> Quay Lai");
                Motor_Driver(DIR_QUAY_PHAI, 200);
                delay_ms(TIME_TURN_180); //Thoi gian quay dau
                //delay_ms(TIME_TURN_90);
                Motor_Driver(DIR_DI_THANG, 0xff);
                delay_ms(DELAY_TURN); VLED=0;
                return;
            }
            if(SensorL+10 < SensorR){  //Lech trai
                Duty_Offset = SensorL;
                PWM_SetDuty(0, Duty_Offset, 0, SensorR);
            }else if(SensorR+10 < SensorL){ //Lech phai
                Duty_Offset = SensorR;
                PWM_SetDuty(0, SensorL, 0, Duty_Offset);
            }else{    //Di thang
                Motor_Driver(DIR_DI_THANG, 0xff);
            }
            return;
        }
    }//End Debug
    if(Check_LowBattery())
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("* Low Battery *");
        lcd_gotoxy(0,1);
        delay_ms(500);
        lcd_puts("Robot Stop..!");
        Debug=1;
        for(time_out=9; time_out>0; time_out--){
            lcd_gotoxy(15,1);
            lcd_putchar(time_out+48);
            delay_ms(800);
        }
        lcd_gotoxy(15,1);
        lcd_putchar('0');
        delay_ms(800);
        time_out=60;
        return;
    }
    //Chuong trinh giai ma me cung
    if(SensorStop == 1){    //Gap mau xanh, dung xe, bao victory
         VLED=1;
         Motor_Driver(DIR_DUNG_LAI, 0);
         lcd_clear();
         lcd_puts(" ROBOT VICTORY! ");
         lcd_gotoxy(0,1);
         lcd_puts("SANGTAOCLUB.NET");
         while(1);  //STOP ROBOT, Wait Reset..
    }
    else if(SensorC<30)  //Lui lai
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Vat Can!");
        lcd_gotoxy(0,1); delay_ms(200);
        lcd_puts("-> Lui Lai");
        Motor_Driver(DIR_LUI_LAI, 200);
        delay_ms(500);
        Motor_Driver(DIR_DUNG_LAI, 0); delay_ms(100);
        //Motor_Driver(DIR_DI_THANG, 0xff);
        //delay_ms(DELAY_TURN);
    }
    else if(SensorC<Ram_Sensor.Center-50 && SensorL<Ram_Sensor.Left1 && SensorR<Ram_Sensor.Right1 && SensorL2<Ram_Sensor.Left2 && SensorR2<Ram_Sensor.Right2)    //Ngo cut
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Het Duong!");
        lcd_gotoxy(0,1); delay_ms(200);
        lcd_puts("-> Quay Lai");
        Motor_Driver(DIR_QUAY_PHAI, 200);
        delay_ms(TIME_TURN_180); //Thoi gian quay dau
        Motor_Driver(DIR_DI_THANG, 0xff);
        delay_ms(DELAY_TURN/2);
    }
    else if(SensorC<Ram_Sensor.Center && SensorL>Ram_Sensor.Left1 && SensorR>Ram_Sensor.Right1 && SensorL2>Ram_Sensor.Left2 && SensorR2>Ram_Sensor.Right2)  //Nga re trai phai
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Nga re LR!");
        lcd_gotoxy(0,1); delay_ms(200);
        lcd_puts("-> Quay Phai");
        Motor_Driver(DIR_DI_THANG, 150);
        lcd_gotoxy(15,1); lcd_putchar('^');
        //while(Read_Sensor(SENSOR_TRUOC) > 50); ////
        delay_ms(300);
        lcd_gotoxy(15,1); lcd_putchar('>');
        Motor_Driver(DIR_QUAY_PHAI, 200);
        delay_ms(TIME_TURN_90);
        Motor_Driver(DIR_DI_THANG, 0xff);
        delay_ms(DELAY_TURN);
    }
    else if(SensorC<Ram_Sensor.Center && SensorL>Ram_Sensor.Left1 && SensorR<Ram_Sensor.Right1 && SensorL2>Ram_Sensor.Left2 && SensorR2<Ram_Sensor.Right2)  //Nga re trai
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Nga Re Trai!");
        lcd_gotoxy(0,1); delay_ms(200);
        lcd_puts("-> Quay Trai");
        Motor_Driver(DIR_DI_THANG, 150);
        lcd_gotoxy(15,1); lcd_putchar('^');
        //while(Read_Sensor(SENSOR_TRUOC) > 50); ////
        delay_ms(300);
        lcd_gotoxy(15,1); lcd_putchar('<');
        Motor_Driver(DIR_QUAY_TRAI, 200);
        delay_ms(TIME_TURN_90);
        Motor_Driver(DIR_DI_THANG, 0xff);
        delay_ms(DELAY_TURN);
    }
    else if(SensorC<Ram_Sensor.Center && SensorL<Ram_Sensor.Left1 && SensorR>Ram_Sensor.Right1 && SensorL2<Ram_Sensor.Left2 && SensorR2>Ram_Sensor.Right2)  //Nga re phai
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Nga Re Phai!");
        lcd_gotoxy(0,1); delay_ms(200);
        lcd_puts("-> Quay Phai");
        Motor_Driver(DIR_DI_THANG, 150);
        lcd_gotoxy(15,1); lcd_putchar('^');
        //while(Read_Sensor(SENSOR_TRUOC) > 50); ////
        delay_ms(300);
        lcd_gotoxy(15,1); lcd_putchar('>');
        Motor_Driver(DIR_QUAY_PHAI, 200);
        delay_ms(TIME_TURN_90);
        Motor_Driver(DIR_DI_THANG, 0xff);
        delay_ms(DELAY_TURN);
    }
    else if(SensorC>Ram_Sensor.Center && SensorL>Ram_Sensor.Left1 && SensorR<Ram_Sensor.Right1 && SensorL2>Ram_Sensor.Left2 && SensorR2<Ram_Sensor.Right2)  //Nga 3 ben trai
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Nga 3 Trai!");
        lcd_gotoxy(0,1); delay_ms(200);
        lcd_puts("-> Di Thang");
        PWM_SetDuty(0, 200, 0, 255);
        delay_ms(DELAY_TURN*2);
    }
    else if(SensorC>Ram_Sensor.Center && SensorL<Ram_Sensor.Left1 && SensorR>Ram_Sensor.Right1 && SensorL2<Ram_Sensor.Left2 && SensorR2>Ram_Sensor.Right2)  //Nga 3 ben phai
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Nga 3 Phai!");
        lcd_gotoxy(0,1); delay_ms(200);
        dir_rand = Read_Random();
        if(dir_rand==1)lcd_puts("-> Di Thang");
        else lcd_puts("-> Quay Phai");
        Motor_Driver(DIR_DI_THANG, 150);
        delay_ms(400);
        if(dir_rand!=1){
            Motor_Driver(DIR_QUAY_PHAI, 200);
            delay_ms(TIME_TURN_90);
            Motor_Driver(DIR_DI_THANG, 0);
        }else delay_ms(DELAY_TURN);
        Motor_Driver(DIR_DI_THANG, 0xff);
        delay_ms(DELAY_TURN);
    }
    else if(SensorC>Ram_Sensor.Center && SensorL>Ram_Sensor.Left1 && SensorR>Ram_Sensor.Right1 && SensorL2>Ram_Sensor.Left2 && SensorR2>Ram_Sensor.Right2)  //Nga 4
    {
        Motor_Driver(DIR_DUNG_LAI, 0);
        lcd_clear();
        lcd_puts("Nga Tu!");
        lcd_gotoxy(0,1); delay_ms(200);
        dir_rand = Read_Random();
        if(dir_rand==1)lcd_puts("-> Di Thang");
        else if(dir_rand==2)lcd_puts("-> Quay Trai");
        else lcd_puts("-> Quay Phai");
        Motor_Driver(DIR_DI_THANG, 150);
        delay_ms(400);
        if(dir_rand>2){
            Motor_Driver(DIR_QUAY_PHAI, 200);
            delay_ms(TIME_TURN_90);
            Motor_Driver(DIR_DI_THANG, 0);
        }else if(dir_rand==2){
            Motor_Driver(DIR_QUAY_TRAI, 200);
            delay_ms(TIME_TURN_90);
            Motor_Driver(DIR_DI_THANG, 0);
        }else delay_ms(DELAY_TURN);
        Motor_Driver(DIR_DI_THANG, 0xff);
        delay_ms(DELAY_TURN);
    }
    else  //Di thang, auto dieu huong
    {
        //Hien thi du lieu cam bien - LCD Debug
        lcd_clear();
        sprintf(str, "L1:%u R1:%i", SensorL, SensorR);
        lcd_puts(str);
        lcd_gotoxy(0,1);
        sprintf(str, "L2:%i R2:%i", SensorL2, SensorR2);
        lcd_puts(str);
        if(!PIND_1){
            delay_ms(20);
            if(!PIND_1){
                    Debug=2;
                    lcd_clear();
                    lcd_puts("Set...");
                    while(!PIND_1);
                    delay_ms(500);
                    return;
            }

        }
        ///////////////////////////////////////////
        if(SensorL < 55 || SensorR < 55){
            if(++Val_1>15){
                Val_1=0;
                Motor_Driver(DIR_DUNG_LAI, 0);
                lcd_clear();
                lcd_puts("Bi Vuong!");
                lcd_gotoxy(0,1); delay_ms(200);
                lcd_puts("-> Lui Lai");
                Motor_Driver(DIR_LUI_LAI, 200);
                delay_ms(500);
            }
        }else Val_1=0;
        delay_ms(30);
        if(SensorL+8 < SensorR){  //Lech trai
            if(SensorL < 40)Duty_Offset = 0;
            else
                Duty_Offset = SensorL-40;
            PWM_SetDuty(0, Duty_Offset, 0, SensorR);
        }else if(SensorR+8 < SensorL){ //Lech phai
            if(SensorR < 40)Duty_Offset = 0;
            else
                Duty_Offset = SensorR-40;
            PWM_SetDuty(0, SensorL, 0, Duty_Offset);
        }else{    //Di thang
            Motor_Driver(DIR_DI_THANG, 0xff);
        }

    } //end if
}




